Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.io
Class BufferedWriter

    java.lang.Object
      |
      +--java.io.Writer
            |
            +--java.io.BufferedWriter

public class BufferedWriter
extends Writer

Write text to a character-output stream, buffering characters so as to provide for the efficient writing of single characters, arrays, and strings.

The buffer size may be specified, or the default size may be accepted. The default is large enough for most purposes.

A newLine() method is provided, which uses the platform's own notion of line separator as defined by the system property `line.separator`. Not all platforms use the newline character ('\n') to terminate lines. Calling this method to terminate each output line is therefore preferred to writing a newline character directly.

In general, a Writer sends its output immediately to the underlying character or byte stream. Unless prompt output is required, it is advisable to wrap a BufferedWriter around any Writer whose write() operations may be costly, such as FileWriters and OutputStreamWriters. For example,

     PrintWriter out
       = new PrintWriter(new BufferedWriter(new FileWriter("foo.out")));

will buffer the PrintWriter's output to the file. Without buffering, each invocation of a print() method would cause characters to be converted into bytes that would then be written immediately to the file, which can be very inefficient.

Since:
  JDK1.1
See Also:
  `PrintWriter`, `FileWriter`, `OutputStreamWriter`

Field Summary

Fields inherited from class java.io.Writer
`lock`

Constructor Summary
`BufferedWriter(Writer out)` Create a buffered character-output stream that uses a default-sized output buffer.
`BufferedWriter(Writer out, int sz)` Create a new buffered character-output stream that uses an output buffer of the given size.

Method Summary
`void` | `close()` Close the stream.
`void` | `flush()` Flush the stream.
`void` | `newLine()` Write a line separator.
`void` | `write(char[] cbuf, int off, int len)` Write a portion of an array of characters.
`void` | `write(int c)` Write a single character.
`void` | `write(String s, int off, int len)` Write a portion of a String.

Methods inherited from class java.io.Writer
`write, write`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### BufferedWriter

    public BufferedWriter(Writer out)

  Create a buffered character-output stream that uses a default-sized output buffer.

Parameters:
  `out` - A Writer

### BufferedWriter

    public BufferedWriter(Writer out,
                          int sz)

  Create a new buffered character-output stream that uses an output buffer of the given size.

Parameters:
  `out` - A Writer
  `sz` - Output-buffer size, a positive integer
Throws:
  `IllegalArgumentException` - If sz is <= 0

Method Detail

### write

    public void write(int c)
               throws IOException

  Write a single character.

  Overrides:
    `write` in class `Writer`
  Parameters:
    `c` - int specifying a character to be written.
  Throws:
    `IOException` - If an I/O error occurs

### write

    public void write(char[] cbuf,
                      int off,
                      int len)
               throws IOException

  Write a portion of an array of characters.

  Ordinarily this method stores characters from the given array into this stream's buffer, flushing the buffer to the underlying stream as needed. If the requested length is at least as large as the buffer, however, then this method will flush the buffer and write the characters directly to the underlying stream. Thus redundant `BufferedWriter`s will not copy data unnecessarily.

  Specified by:
    `write` in class `Writer`
  Parameters:
    `cbuf` - A character array
    `off` - Offset from which to start reading characters
    `len` - Number of characters to write
  Throws:
    `IOException` - If an I/O error occurs

### write

    public void write(String s,
                      int off,
                      int len)
               throws IOException

  Write a portion of a String.

  Overrides:
    `write` in class `Writer`
  Parameters:
    `s` - String to be written
    `off` - Offset from which to start reading characters
    `len` - Number of characters to be written
  Throws:
    `IOException` - If an I/O error occurs

### newLine

    public void newLine()
                 throws IOException

  Write a line separator. The line separator string is defined by the system property `line.separator`, and is not necessarily a single newline ('\n') character.

  Throws:
    `IOException` - If an I/O error occurs

### flush

    public void flush()
               throws IOException

  Flush the stream.

  Specified by:
    `flush` in class `Writer`
  Throws:
    `IOException` - If an I/O error occurs

### close

    public void close()
               throws IOException

  Close the stream.

  Specified by:
    `close` in class `Writer`
  Throws:
    `IOException` - If an I/O error occurs

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2002 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.